function MustToggleOnKeyPerSettings(key) {
  return (((key == "\"") && (Script.ReadSetting("Toggle double quotes", "1") == "1")) ||
    ((key == "'") && (Script.ReadSetting("Toggle single quotes", "1") == "1")) ||
    ((key == "(") && (Script.ReadSetting("Toggle brackets", "1") == "1")) ||
    ((key == "[") && (Script.ReadSetting("Toggle square brackets", "1") == "1")) ||
    ((key == "{") && (Script.ReadSetting("Toggle curly braces", "1") == "1")));
}

function ToggleQuotes(&key, quotechar, wrapchar_s, wrapchar_e) {
  if (key == quotechar) {
    if (MustToggleOnKeyPerSettings(key)) {
      var s = Editor.SelText;
      if (s != "") {
        if (wrapchar_s == "")
          wrapchar_s = quotechar;
        if (wrapchar_e == "")
          wrapchar_e = quotechar;
        if ((s[1] == wrapchar_s) && (s[Length(s)] == wrapchar_e))
          Editor.SelText = Copy(s, 2, Length(s) - 2);
        else {
          Editor.SelText = wrapchar_s + s + wrapchar_e;
        }
        key = ""; //since we used the key for our own purposes
                  //clear the key so it won't get sent to editor
      }
    }
  }
}

function OnKeyDown(key, shift) {
  ToggleQuotes(key, "\"", "", "");
  ToggleQuotes(key, "'", "'", "'");
  ToggleQuotes(key, "(", "(", ")");
  ToggleQuotes(key, "[", "[", "]");
  ToggleQuotes(key, "{", "{", "}");
}

Script.ConnectSignal("keydown", &OnKeyDown);

